;Draw 3d Pipe Shape
(apply '(lambda (/ a b c id halfod halfid a90 a270 ip1 ip2 cp1 cp2 d1 d2 d3 d4 d5 d6
                   cp3  cp5  cp5  cp6  cp7  cp8  cp9  cp10 cp11 cp12 cp13 cp14
                   cp15 cp16 cp17 cp18 cp19 cp20 cp21 cp22 cp23 cp24 cp25 cp26
                   p1  p2  p3  p4  p5  p6  p7  p8  p9  p10 p11 p12 p13 p14 p15 p16
                   p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 p29 p20 p31 p32
                   p33 p34 p35 p36 p37 p37 p39 p40 p41 p42 p43 p44 p45 p46 p47 p48
                   p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p65)

   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Top of Pipe point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Bottom of Pipe point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] Center point: "))
      )
   )
   (if (= STL_DRAW_MODE "stl_db")                          ;Draw Mode
      (setq id (- (nth 1 shp_data) 1.0))
      (setq id (- (nth 1 shp_data) (* (nth 3 SHP_DATA) 2.0)))
   )
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq halfod (/ (nth 1 shp_data) 2.0)
            halfid (/ id 2.0)
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1)
            (setq cp1 (list (car ip1) (cadr ip1) (- (caddr ip1) halfod))
                  cp2 (list (car ip2) (cadr ip2) (- (caddr ip2) halfod))
            )
         )
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) halfod))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) halfod))
            )
         )
         ((= b 3) (setq cp1 ip1 cp2 ip2))
      )
      (setq d1 (* halfod (sin (* pi 0.125)))
            d2 (* halfod (sin (* pi 0.25)))
            d3 (* halfod (cos (* pi 0.125)))
            d4 (* halfid (sin (* pi 0.125)))
            d5 (* halfid (sin (* pi 0.25)))
            d6 (* halfid (cos (* pi 0.125)))
            cp3 (polar cp1 a270 d1)
            cp4 (polar cp1 a270 d2)
            cp5 (polar cp1 a270 d3)
            cp6 (polar cp1 a90 d1)
            cp7 (polar cp1 a90 d2)
            cp8 (polar cp1 a90 d3)

            cp9  (polar cp2 a270 d1)
            cp10 (polar cp2 a270 d2)
            cp11 (polar cp2 a270 d3)
            cp12 (polar cp2 a90 d1)
            cp13 (polar cp2 a90 d2)
            cp14 (polar cp2 a90 d3)

            cp15 (polar cp1 a270 d4)
            cp16 (polar cp1 a270 d5)
            cp17 (polar cp1 a270 d6)
            cp18 (polar cp1 a90 d4)
            cp19 (polar cp1 a90 d5)
            cp20 (polar cp1 a90 d6)

            cp21 (polar cp2 a270 d4)
            cp22 (polar cp2 a270 d5)
            cp23 (polar cp2 a270 d6)
            cp24 (polar cp2 a90 d4)
            cp25 (polar cp2 a90 d5)
            cp26 (polar cp2 a90 d6)

      )
      (setq p1  (polar cp1 a270 halfod)
            p9  (polar cp1 a90  halfod)
            p17 (polar cp2 a270 halfod)
            p25 (polar cp2 a90  halfod)
            p2  (list (car cp5) (cadr cp5) (+ (caddr cp5) d1))
            p3  (list (car cp4) (cadr cp4) (+ (caddr cp4) d2))
            p4  (list (car cp3) (cadr cp3) (+ (caddr cp3) d3))
            p5  (list (car cp1) (cadr cp1) (+ (caddr cp1) halfod))
            p6  (list (car cp6) (cadr cp6) (+ (caddr cp6) d3))
            p7  (list (car cp7) (cadr cp7) (+ (caddr cp7) d2))
            p8  (list (car cp8) (cadr cp8) (+ (caddr cp8) d1))
            p10 (list (car cp8) (cadr cp8) (- (caddr cp8) d1))
            p11 (list (car cp7) (cadr cp7) (- (caddr cp7) d2))
            p12 (list (car cp6) (cadr cp6) (- (caddr cp6) d3))
            p13 (list (car cp1) (cadr cp1) (- (caddr cp1) halfod))
            p14 (list (car cp3) (cadr cp3) (- (caddr cp3) d3))
            p15 (list (car cp4) (cadr cp4) (- (caddr cp4) d2))
            p16 (list (car cp5) (cadr cp5) (- (caddr cp5) d1))

            p18 (list (car cp11) (cadr cp11) (+ (caddr cp11) d1))
            p19 (list (car cp10) (cadr cp10) (+ (caddr cp10) d2))
            p20 (list (car cp9)  (cadr cp9)  (+ (caddr cp9)  d3))
            p21 (list (car cp2)  (cadr cp2)  (+ (caddr cp2)  halfod))
            p22 (list (car cp12) (cadr cp12) (+ (caddr cp12) d3))
            p23 (list (car cp13) (cadr cp13) (+ (caddr cp13) d2))
            p24 (list (car cp14) (cadr cp14) (+ (caddr cp14) d1))
            p26 (list (car cp14) (cadr cp14) (- (caddr cp14) d1))
            p27 (list (car cp13) (cadr cp13) (- (caddr cp13) d2))
            p28 (list (car cp12) (cadr cp12) (- (caddr cp12) d3))
            p29 (list (car cp2)  (cadr cp2)  (- (caddr cp2) halfod))
            p30 (list (car cp9)  (cadr cp9)  (- (caddr cp9) d3))
            p31 (list (car cp10) (cadr cp10) (- (caddr cp10) d2))
            p32 (list (car cp11) (cadr cp11) (- (caddr cp11) d1))

            p33  (polar cp1 a270 halfid)
            p41  (polar cp1 a90  halfid)
            p49 (polar cp2 a270 halfid)
            p57 (polar cp2 a90  halfid)
            p34 (list (car cp17) (cadr cp17) (+ (caddr cp17) d4))
            p35 (list (car cp16) (cadr cp16) (+ (caddr cp16) d5))
            p36 (list (car cp15) (cadr cp15) (+ (caddr cp15) d6))
            p37 (list (car cp1)  (cadr cp1)  (+ (caddr cp1) halfid))
            p38 (list (car cp18) (cadr cp18) (+ (caddr cp18) d6))
            p39 (list (car cp19) (cadr cp19) (+ (caddr cp19) d5))
            p40 (list (car cp20) (cadr cp20) (+ (caddr cp20) d4))
            p42 (list (car cp20) (cadr cp20) (- (caddr cp20) d4))
            p43 (list (car cp19) (cadr cp19) (- (caddr cp19) d5))
            p44 (list (car cp18) (cadr cp18) (- (caddr cp18) d6))
            p45 (list (car cp1)  (cadr cp1)  (- (caddr cp1) halfid))
            p46 (list (car cp15) (cadr cp15) (- (caddr cp15) d6))
            p47 (list (car cp16) (cadr cp16) (- (caddr cp16) d5))
            p48 (list (car cp17) (cadr cp17) (- (caddr cp17) d4))

            p50 (list (car cp23) (cadr cp23) (+ (caddr cp23) d4))
            p51 (list (car cp22) (cadr cp22) (+ (caddr cp22) d5))
            p52 (list (car cp21) (cadr cp21) (+ (caddr cp21)  d6))
            p53 (list (car cp2)  (cadr cp2)  (+ (caddr cp2)  halfid))
            p54 (list (car cp24) (cadr cp24) (+ (caddr cp24) d6))
            p55 (list (car cp25) (cadr cp25) (+ (caddr cp25) d5))
            p56 (list (car cp26) (cadr cp26) (+ (caddr cp26) d4))
            p58 (list (car cp26) (cadr cp26) (- (caddr cp26) d4))
            p59 (list (car cp25) (cadr cp25) (- (caddr cp25) d5))
            p60 (list (car cp24) (cadr cp24) (- (caddr cp24) d6))
            p61 (list (car cp2)  (cadr cp2)  (- (caddr cp2) halfid))
            p62 (list (car cp21) (cadr cp21) (- (caddr cp21) d6))
            p63 (list (car cp22) (cadr cp22) (- (caddr cp22) d5))
            p64 (list (car cp23) (cadr cp23) (- (caddr cp23) d4))

      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8  p9  p10 p11 p12 p13 p14 p15 p16
               p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 p29 p30 p31 p32
               p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 p46 p47 p48
               p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p64 ""
                2   1  17 18 ""
                3   2  18 19 ""
                4   3  19 20 ""
                5   4  20 21 ""
                6   5  21 22 ""
                7   6  22 23 ""
                8   7  23 24 ""
                9   8  24 25 ""
               10   9  25 26 ""
               11  10  26 27 ""
               12  11  27 28 ""
               13  12  28 29 ""
               14  13  29 30 ""
               15  14  30 31 ""
               16  15  31 32 ""
                1  16  32 17 ""

               34  33  49 50 ""
               35  34  50 51 ""
               36  35  51 52 ""
               37  36  52 53 ""
               38  37  53 54 ""
               39  38  54 55 ""
               40  39  55 56 ""
               41  40  56 57 ""
               42  41  57 58 ""
               43  42  58 59 ""
               44  43  59 60 ""
               45  44  60 61 ""
               46  45  61 62 ""
               47  46  62 63 ""
               48  47  63 64 ""
               33  48  64 49 ""

                2  -1 33 -34 ""
                3  -2 34 -35 ""
                4  -3 35 -36 ""
                5  -4 36 -37 ""
                6  -5 37 -38 ""
                7  -6 38 -39 ""
                8  -7 39 -40 ""
                9  -8 40 -41 ""
               10  -9 41 -42 ""
               11 -10 42 -43 ""
               12 -11 43 -44 ""
               13 -12 44 -45 ""
               14 -13 45 -46 ""
               15 -14 46 -47 ""
               16 -15 47 -48 ""
                1 -16 48 -33 ""

               18 -17 49 -50 ""
               19 -18 50 -51 ""
               20 -19 51 -52 ""
               21 -20 52 -53 ""
               22 -21 53 -54 ""
               23 -22 54 -55 ""
               24 -23 55 -56 ""
               25 -24 56 -57 ""
               26 -25 57 -58 ""
               27 -26 58 -59 ""
               28 -27 59 -60 ""
               29 -28 60 -61 ""
               30 -29 61 -62 ""
               31 -30 62 -63 ""
               32 -31 63 -64 ""
               17 -32 64 -49 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
