;Draw W Cross Section
(apply '(lambda ( / a b c d e f g h i j k l m n p q r z lp)
   (setq p (getvar "blipmode"))
   (setvar "blipmode" 1)
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq a
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Center Top of Flange point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Center Bottom of Flange point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] Center of Web at X Axis: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Center of Web at Y Axis: "))
         )
      )
      (command ".undo" "g")
      (setq z (getvar "osmode"))
      (setvar "osmode" 0)
      (initget 1)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (setq n (getangle a "\nIndicate angle of Web: "))
            (if (and (> n 0) (<= n pi)) (setq n (+ n pi)))
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq n (getangle a "\nIndicate angle of Web: "))
            (if (or (= n 0) (and (> n pi) (< n (* 2 pi)))) (setq n (+ n pi)))
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq n (getangle a "\nIndicate direction of X Axis: "))
            (setvar "blipmode" 0)
            (stl_set_lyr "stl-cntr")
            (command ".line"
               (polar a n 6.0)
               (polar a (+ n pi) 6.0) "")
            (setq n (+ n (* pi 0.5)))
            (setq a (polar a (+ n pi) (/ (cadr SHP_DATA) 2.0)))
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq n (getangle a "\nIndicate direction of Y Axis: "))
            (setq a (polar a (+ n pi) (/ (cadr SHP_DATA) 2.0)))
         )
      )
      (setq lp (polar a n (nth 1 SHP_DATA)))
      (setq q (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))  ;Web thickness
      (setq r (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 4 SHP_DATA)))  ;Flange thickness
      (setvar "blipmode" 0)
      (stl_set_lyr "stl-cntr")
      (command ".line"
         (polar a (+ n pi) 6.0)
         (polar a n (+ (nth 1 SHP_DATA) 6.0)) "")
      (setq b (polar a (+ n (* pi 0.5)) (/ (nth 3 SHP_DATA) 2.0))
            m (polar a n (nth 5 SHP_DATA))
            e (polar m (angle a b) (/ q 2.0))
            m (polar e (angle a b) (- (nth 5 SHP_DATA) r))
            a (polar a (angle b a) (distance b a))
      )
      (stl_set_lyr "stl-objt")
      (command ".pline" a "w" 0.0 "" b
         (setq c (polar b n r))
         (setq d (polar m (+ n pi) (- (nth 5 SHP_DATA) r))) "a" e "l"
         (setq f (polar e n (- (cadr SHP_DATA) (* (nth 5 SHP_DATA) 2.0)))) "a"
         (setq g (polar d n (- (cadr SHP_DATA) (* r 2.0)))) "l"
         (setq h (polar c n (distance d g)))
         (setq i (polar b n (nth 1 SHP_DATA)))
         (setq j (polar i (angle b a) (nth 3 SHP_DATA)))
         (setq k (polar h (angle i j) (distance i j)))
         (setq l (polar k (angle g h) (distance g h))) "a"
         (polar f (angle b a) q) "l"
         (polar e (angle b a) q) "a"
         (polar l (angle g d) (distance g d)) "l"
         (polar k (angle h c) (distance h c)) "c")
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ n (* 0.5 pi))) "l" "")
         )
      )
      (setvar "osmode" z)
      (setvar "blipmode" p)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" p)
)
'()
)
