;S Shape Cross Section
(apply '(lambda (/ a ang ang1 ang2 ang3 p1 p2 p3 p4 p5 p6 p7 p8
                   cp1 cp2 p9 p10 p11 p12 p13 p q r lp)
   (setq p (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq p1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Center Top of Flange point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Center Bottom of Flange point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] Center of Web at X Axis: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Center fo Web at Y Axis: "))
         )
      )
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (initget 1)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (setq ang (getangle p1 "\nIndicate angle of Web: "))
            (if (and (> ang 0) (<= ang pi)) (setq ang (+ ang pi)))
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq ang (getangle p1 "\nIndicate angle of Web: "))
            (if (or (<= ang 0) (> ang pi))  (setq ang (+ ang pi)))
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq ang (getangle p1 "\nIndicate direction of X Axis: "))
            (setvar "blipmode" 0)
            (stl_set_lyr "stl-cntr")
            (command ".line"
               (polar p1 ang 6.0)
               (polar p1 (+ ang pi) 6.0) "")
            (setq ang (+ ang (* pi 0.5)))
            (setq p1 (polar p1 (+ ang pi) (/ (cadr SHP_DATA) 2.0)))
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq ang (getangle p1 "\nIndicate direction of Y Axis: "))
            (setq p1 (polar p1 (+ ang pi) (/ (cadr SHP_DATA) 2.0)))
         )
      )
      (setq lp (polar p1 ang (nth 1 SHP_DATA)))
      (setq q (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))  ;Web thickness
      (setvar "blipmode" 0)
      (stl_set_lyr "stl-cntr")
      (stl_draw_line (list (polar p1 (+ ang pi) 6.0) (polar p1 ang (+ (cadr SHP_DATA) 6.0))) nil)
      (setq ang1 (+ ang (* pi 0.5) (nth 7 SHP_DATA))
            ang2 (+ ang1 (* pi 0.5))
            ang3 (- ang (nth 7 SHP_DATA))
            p2 (polar p1 (+ ang (* pi 0.5)) (/ (nth 3 SHP_DATA) 2))
            p5 (polar p1 ang (nth 5 SHP_DATA))
            p5 (polar p5 (angle p1 p2) (/ q 2))
            cp1 (polar p5 (angle p1 p2) (nth 6 SHP_DATA))
            p4 (polar cp1 ang2 (nth 6 SHP_DATA))
            p3 (inters p4 (polar p4 ang1 6.0) p2 (polar p2 ang 6.0) nil)
            p6 (polar p5 ang (- (nth 1 SHP_DATA) (* (nth 5 SHP_DATA) 2.0)))
            cp2 (polar p6 (angle p1 p2) (nth 6 SHP_DATA))
            p7 (polar cp2 ang3 (nth 6 SHP_DATA))
            p9 (polar p2 ang (nth 1 SHP_DATA))
            p1 (polar p1 (angle p2 p1) (distance p2 p1))
       )
       (stl_set_lyr "stl-objt")
       (command ".pline" p1 "w" "0.0" "" p2 p3 p4 "a" p5 "l" p6 "a" p7 "l"
          (setq p8 (polar p9 (angle p3 p2) (distance p3 p2))) p9
          (setq p10 (polar p9 (angle p2 p1) (nth 3 SHP_DATA)))
          (setq p11 (polar p10 (angle p3 p2) (distance p3 p2)))
          (setq p12 (polar p11 (angle p4 p3) (distance p4 p3))) "a"
          (setq p13 (polar p6 (angle p2 p1) q)) "l"
          (polar p5 (angle p2 p1) q) "a"
          (polar p4 (angle p7 p12) (distance p7 p12)) "l"
          (polar p11 (angle p8 p3) (distance p8 p3)) "c"
      )
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang (* 0.5 pi))) "l" "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" p)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" p)
)
'()
)




