;Draw C Shape Cross Section
(apply '(lambda ( / a b c d e f g ang1 ang2 ang3 ang4 p1 p2 p3 p4 p5 p6 p7 p8 p9
                    p10 cpt d1 d2 l m n r)
   (setq a (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq p1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Heel Top of Flange point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Heel Bottom of Flange point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] Face of Web at X Axis: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Y Axis at Top of Flange: "))
         )
      )
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (initget 1)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (if (and (> ang1 0) (<= ang1 pi)) (setq ang1 (+ ang1 pi)))
            (setq ang1 (getangle p1 "\nIndicate angle of Web: "))
            (setq p0 p1 p11 p1)
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq ang1 (getangle p1 "\nIndicate angle of Web: "))
            (if (or (<= ang1 0) (> ang1 pi)) (setq ang1 (+ ang1 pi)))
            (setq p0 p1 p11 p1)
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq ang1 (getangle p1 "\nIndicate X Axis direction: "))
            (stl_set_lyr "stl-cntr")
            (setvar "blipmode" 0)
            (command ".line"
               (polar p1 ang1 6.0)
               (polar p1 (+ ang1 pi) 6.0) "")
            (setq ang1 (+ ang1 (* pi 0.5)))
            (setq p1 (polar p1 (+ ang1 pi) (/ (cadr SHP_DATA) 2.0)))
            (setq p0 p1 p11 p1)
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq p0 p1)
            (setq ang1 (getangle p1 "\nIndicate Y Axis direction: "))
            (if (and (> ang1 0) (<= ang1 pi)) (setq ang1 (+ ang1 pi)))
            (stl_set_lyr "stl-cntr")
            (setvar "blipmode" 0)
            (command ".line"
               (polar p1 (+ ang1 pi) 6.0)
               (polar p1 ang1 (+ (nth 1 SHP_DATA) 6.0)) "")
            (setq p1 (polar p0 (+ ang1 (* pi 1.5)) (nth 8 SHP_DATA)))
            (setq p11 p1)
         )
      )
      (setq lp (polar p1 ang1 (nth 1 SHP_DATA)))
      (setq b (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))  ;Web thickness
      (setq ad nil cp nil)
      (setq e
         (list
            (setq ang2 (+ ang1 (* pi 0.5)))
            (+ (+ ang1 pi) (nth 7 SHP_DATA))
            (- ang1 (nth 7 SHP_DATA))
         )
      )
      (setq f
         (list
            (+ ang1 (* pi 1.5))
            (- (+ ang1 pi) (nth 7 SHP_DATA))
            (+ ang1 (nth 7 SHP_DATA))
         )
      )
      (foreach f (list e f)
         (setq p1  (polar p0 (+ (car f) pi) (distance p0 p11)))
         (setq p2  (polar p1 (car f) (nth 3 SHP_DATA))
               p5  (polar p1 ang1 (nth 5 SHP_DATA))
               p5  (polar p5 (car f) b)
               cpt (polar p5 (car f) (nth 6 SHP_DATA))
               p4  (polar cpt (cadr f) (nth 6 SHP_DATA))
               p3  (inters p4 (polar p4 (+ (cadr f) (* 0.5 pi)) 6.0) p2 (polar p2 ang1 6.0) nil)
               p6  (polar p5 ang1 (- (nth 1 SHP_DATA) (* (nth 5 SHP_DATA) 2)))
               cpt (polar p6 (car f) (nth 6 SHP_DATA))
               p7  (polar cpt (caddr f) (nth 6 SHP_DATA))
               p10 (polar p1 ang1 (nth 1 SHP_DATA))
               p9  (polar p10 (car f) (nth 3 SHP_DATA))
               p8  (polar p9 (angle p3 p2) (distance p3 p2))
         )
         (setq ad
            (append ad
               (list
                  (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p10 p10 p1)
               )
            )
         )
         (setq cp (append cp (list p2 p9)))
      )
      (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp))
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (grvecs d1)
      (princ "\n[DRAG] Toe direction and [PICK]: ")
      (grread 5)
      (while (/= 3 (car (setq l (grread 5))))
         (if (= 5 (car l))
            (progn
               (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang2 12.0) p1 p2 nil)))
               (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang2 12.0) p3 p4 nil)))
               (if (< n m)
                  (if (not (equal t1 d1))
                     (progn
                        (grvecs t1)
                        (grvecs d1)
                        (setq t1 d1)
                     )
                  )
                  (if (not (equal t1 d2))
                     (progn
                        (grvecs t1)
                        (grvecs d2)
                        (setq t1 d2)
                     )
                  )
               )
            )
         )
      )
      (grvecs t1)
      (setq d1 (cdr t1))
      (setvar "blipmode" 0)
      (stl_set_lyr "stl-objt")
      (command "pline" (car d1) "w" 0.0 "" (nth 1 d1) (nth 3 d1) (nth 5 d1) "a"
         (nth 7 d1) "l" (nth 9 d1) "a"
         (nth 11 d1) "l" (nth 13 d1) (nth 15 d1) (nth 17 d1) "c")
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang1 (* 0.5 pi))) "l" "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)

