;Angle Shape Cross Section

(apply '(lambda ( / a b c d e f l m n r d1 d2 t1 ad cp c1 lp
                    ang1 ang2 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11)
   (setq a (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq p1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Top of Angle at Heel: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Bottom of Angle at Heel: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] X Axis at Face of Angle: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Y Axis at Face of Angle: "))
         )
      )
      (initget 1)
      (setq b (nth 1 SHP_DATA) c (nth 2 SHP_DATA))
      (setq ang1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getangle p1 (strcat "\nIndicate direction of " (rtos b 4) " Leg: ")))
            ((= STL_INPUT_MODE "stl_ib") (getangle p1 (strcat "\nIndicate direction of " (rtos b 4) " Leg: ")))
            ((= STL_INPUT_MODE "stl_ic") (getangle p1 "\nIndicate X Axis in direction of opposite leg: "))
            ((= STL_INPUT_MODE "stl_id") (getangle p1 "\nIndicate Y Axis in direction of opposite leg: "))
         )
      )
      (setq lp p1)
      (setq d (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))   ;Draw Mode
      (setq e (* d 0.33) ad nil cp nil)
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (setq ang2
               (if (and (> ang1 (* pi 0.5)) (>= ang1 (* pi 0.5)))
                  (+ ang1 (* pi 0.5))
                  (+ ang1 (* pi 1.5))
               )
            )
            (foreach f (list ang2 (+ ang2 pi))
               (setq p2 (polar p1 ang1 (nth 1 SHP_DATA)))
               (setq p9 (polar p1 f (nth 2 SHP_DATA)))
               (setq p3 (polar p2 f e))
               (setq p8 (polar p9 ang1 e))
               (setq p5 (polar p1 ang1 (nth 5 SHP_DATA)) p5 (polar p5 f d))
               (setq p6 (polar p1 f (nth 5 SHP_DATA)) p6 (polar p6 ang1 d))
               (setq p4 (polar p5 ang1 (- (nth 1 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p7 (polar p6 f (- (nth 2 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p10 p9 p11 (polar p9 ang1 (nth 1 SHP_DATA)))
               (setq ad (append ad (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p1))))
               (setq cp (append cp (list p10 p11)))
            )
            (if (/= b c)
               (princ (strcat "\n[DRAG] direction of " (rtos c 4) " Leg and [PICK]:"))
               (princ "\n[DRAG] diretion of opposite leg and [PICK]:")
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq ang2
               (if (and (> ang1 (* pi 0.5)) (>= ang1 (* pi 0.5)))
                  (+ ang1 (* pi 1.5))
                  (+ ang1 (* pi 0.5))
               )
            )
            (foreach f (list ang2 (+ ang2 pi))
               (setq p2 (polar p1 ang1 (nth 1 SHP_DATA)))
               (setq p9 (polar p1 f (nth 2 SHP_DATA)))
               (setq p3 (polar p2 f e))
               (setq p8 (polar p9 ang1 e))
               (setq p5 (polar p1 ang1 (nth 5 SHP_DATA)) p5 (polar p5 f d))
               (setq p6 (polar p1 f (nth 5 SHP_DATA)) p6 (polar p6 ang1 d))
               (setq p4 (polar p5 ang1 (- (nth 1 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p7 (polar p6 f (- (nth 2 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p10 p9 p11 (polar p9 ang1 (nth 1 SHP_DATA)))
               (setq ad (append ad (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p1))))
               (setq cp (append cp (list p10 p11)))
            )
            (if (/= b c)
               (princ (strcat "\n[DRAG] direction of " (rtos c 4) " Leg and [PICK]:"))
               (princ "\n[DRAG] diretion of opposite leg and [PICK]:")
            )
         )
         ((= STL_INPUT_MODE "stl_ic")             ;X Axis
            (setq ang2 ang1 ang1 (+ ang2 (* pi 0.5)) c1 p1)
            (stl_set_lyr "stl-cntr")
            (stl_draw_line (list (polar c1 ang2 (+ 6.0 (nth 2 SHP_DATA))) (polar c1 (+ ang2 pi) 6.0)) nil)
            (foreach f (list ang1 (+ ang1 pi))
               (setq p1 (polar c1 (+ f pi) (nth 6 SHP_DATA)))
               (setq p2 (polar p1 f (nth 1 SHP_DATA)))
               (setq p9 (polar p1 ang2 (nth 2 SHP_DATA)))
               (setq p3 (polar p2 ang2 e))
               (setq p8 (polar p9 f e))
               (setq p5 (polar p1 f (nth 5 SHP_DATA)) p5 (polar p5 ang2 d))
               (setq p6 (polar p1 ang2 (nth 5 SHP_DATA)) p6 (polar p6 f d))
               (setq p4 (polar p5 f (- (nth 1 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p7 (polar p6 ang2 (- (nth 2 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p10 p2 p11 (polar p2 ang2 (nth 1 SHP_DATA)))
               (setq ad (append ad (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p1))))
               (setq cp (append cp (list p10 p11)))
            )
            (princ (strcat "\n[DRAG] Angle direction about Axis and [PICK]:"))
         )
         ((= STL_INPUT_MODE "stl_id")             ;Y Axis
            (setq ang2 ang1 ang1 (+ ang2 (* pi 0.5)) c1 p1)
            (stl_set_lyr "stl-cntr")
            (stl_draw_line (list (polar c1 ang2 (+ 6.0 (nth 1 SHP_DATA))) (polar c1 (+ ang2 pi) 6.0)) nil)
            (foreach f (list ang1 (+ ang1 pi))
               (setq p1 (polar c1 (+ f pi) (nth 7 SHP_DATA)))
               (setq p2 (polar p1 f (nth 2 SHP_DATA)))
               (setq p9 (polar p1 ang2 (nth 1 SHP_DATA)))
               (setq p3 (polar p2 ang2 e))
               (setq p8 (polar p9 f e))
               (setq p5 (polar p1 f (nth 5 SHP_DATA)) p5 (polar p5 ang2 d))
               (setq p6 (polar p1 ang2 (nth 5 SHP_DATA)) p6 (polar p6 f d))
               (setq p4 (polar p5 f (- (nth 2 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p7 (polar p6 ang2 (- (nth 1 SHP_DATA) (+ (nth 5 SHP_DATA) (- d e)))))
               (setq p10 p2 p11 (polar p2 ang2 (nth 2 SHP_DATA)))
               (setq ad (append ad (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p1))))
               (setq cp (append cp (list p10 p11)))
            )
            (princ (strcat "\n[DRAG] Angle direction about Axis and [PICK]:"))
         )
      )
      (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp) ang1 (+ (angle p1 p2) (* pi 0.5)))
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (grvecs d1)
      (grread 5)
      (while (/= 3 (car (setq l (grread 5))))
         (if (= 5 (car l))
            (progn
               (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p1 p2 nil)))
               (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p3 p4 nil)))
               (if (< n m)
                  (if (not (equal t1 d1))
                     (progn
                        (grvecs t1)
                        (grvecs d1)
                        (setq t1 d1)
                     )
                  )
                  (if (not (equal t1 d2))
                     (progn
                        (grvecs t1)
                        (grvecs d2)
                        (setq t1 d2)
                     )
                  )
               )
            )
         )
      )
      (grvecs t1)
      (setq d1 (cdr t1))
      (stl_set_lyr "stl-objt")
      (command ".pline" (car d1) "w" 0.0 ""
         (nth 1 d1) (nth 3 d1) "a" (nth 5 d1) "l"
         (nth 7 d1) "a" (nth 9 d1) "l"
         (nth 11 d1) "a" (nth 13 d1) "l" (nth 15 d1) "c")
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang1 (* 0.5 pi))) "l" "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)
