;Draw W Shape Elevation
(apply '(lambda (/ a b c d e f g r p1 p2 p3 p4 p5 p6 p7 p8 lp)
   (if (= STL_VIEW_MODE "stl_va")
      (princ (strcat "\nDrawing Front Elevation of [" (nth 0 SHP_DATA) "]"))
      (princ (strcat "\nDrawing Rear Elevation of [" (nth 0 SHP_DATA) "]"))
   )
   (if (not (setq lp (getpoint "\n[PICK] Start point: ")))
      (setq lp (getvar "lastpoint"))
   )
   (while (setq p1 lp p4 (getpoint lp "\n[PICK] End point: "))
      (setq lp p4)
      (cond
         ((< (car p4) (car p1)) (setq e p4 p4 p1 p1 e))
         ((and (< (cadr p4) (cadr p1)) (= (car p4) (car p1))) (setq e p4 p4 p1 p1 e))
      )
      (setq e (nth 1 SHP_DATA))                                        ;Beam Depth
      (setq f (if (= STL_DRAW_MODE "stl_da") (nth 4 SHP_DATA) 0.5))    ;Flange Thickness
      (setq g (if (= STL_INPUT_MODE "stl_ia") (angle p1 p4) (angle p4 p1)))
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (if (= STL_INPUT_MODE "stl_ic")
         (progn
            (stl_set_lyr "stl-cntr")
            (stl_draw_line (list (polar p1 g 6.0) (polar p4 (stl_180 g) 6.0)) nil)
            (setq p1 (polar p1 (stl_90 g) (/ e 2.0)))
            (setq p4 (polar p4 (stl_90 g) (/ e 2.0)))
         )
      )
      (setq p2 (polar p1 (stl_270 g) e))
      (setq p3 (polar p4 (stl_270 g) e))
      (setq p5 (polar p1 (stl_270 g) f))
      (setq p6 (polar p4 (stl_270 g) f))
      (setq p7 (polar p2 (stl_90  g) f))
      (setq p8 (polar p3 (stl_90  g) f))
      (setq a (list p1 p2 p3 p4))
      (setq b (list p5 p6))
      (setq c (list p7 p8))
      (stl_set_lyr "stl-objt")
      (stl_draw_line a t)
      (stl_draw_line b nil)
      (stl_draw_line c nil)
      (setvar "osmode" r)
      (command ".undo" "e")
      (if (= STL_VIEW_MODE "stl_va")
         (princ (strcat "\nDrawing Front Elevation of [" (nth 0 SHP_DATA) "]"))
         (princ (strcat "\nDrawing Rear Elevation of [" (nth 0 SHP_DATA) "]"))
      )
      (setvar "lastpoint" lp)
   )
)
'()
)
