;Draw WT Shape Front View
(apply '(lambda ( / ang a b c d e f g h i j k l m n r lp
                    ad cp p1 p2 p3 p4 p5 p6 p7 p8 d1 d2 t1)
   (setq a (getvar "blipmode"))
   (if (= STL_VIEW_MODE "stl_va")
      (princ (strcat "\nDrawing Front Elevation of [" (nth 0 SHP_DATA) "]"))
      (princ (strcat "\nDrawing Rear Elevation of [" (nth 0 SHP_DATA) "]"))
   )
   (while (setq p1 (getpoint "\n[PICK] Start point: "))
      (initget 1)
      (setq p2 (getpoint p1 "\n[PICK] End point: ") lp p2)
      (setq ang (angle p1 p2) ad nil cp nil)
      (setq j (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 1.5)))
            (setq p3 (polar p1 i (nth 1 SHP_DATA)))
            (setq p4 (polar p2 i (nth 1 SHP_DATA)))
            (setq p5 (polar p1 i j) p6 (polar p2 i j))
            (setq p7 (polar p4 (+ i pi) j) p8 (polar p3 (+ i pi) j))
            (setq ad
               (list
                  (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6)
                  (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p7 p8)
               )
            )
            (setq cp (list p1 p2 p3 p4))
         )
         ((= STL_INPUT_MODE "stl_ib")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 0.5)))
            (setq p3 (polar p1 i (nth 1 SHP_DATA)))
            (setq p4 (polar p2 i (nth 1 SHP_DATA)))
            (setq p5 (polar p1 i j) p6 (polar p2 i j))
            (setq p7 (polar p4 (+ i pi) j) p8 (polar p3 (+ i pi) j))
            (setq ad
               (list
                  (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6)
                  (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p7 p8)
               )
            )
            (setq cp (list p1 p2 p3 p4))
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq i (+ ang (* pi 1.5)) p7 p1 p8 p2)
            (stl_set_lyr "stl-cntr")
            (command ".line"
               (polar p1 (+ ang pi) 6.0)
               (polar p2 ang 6.0) "")
            (foreach f (list i (+ i pi))
               (setq p1 (polar p7 f (nth 6 SHP_DATA)))
               (setq p2 (polar p8 f (nth 6 SHP_DATA)))
               (setq p3 (polar p1 (+ f pi) (nth 1 SHP_DATA)))
               (setq p4 (polar p2 (+ f pi) (nth 1 SHP_DATA)))
               (setq p5 (polar p1 (+ f pi) j))
               (setq p6 (polar p2 (+ f pi) j))
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6))
                  )
               )
               (setq cp (append cp (list p3 p4)))
            )
         )
      )
      (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp))
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (grvecs d1)
      (princ "\n[DRAG] Web direction and [PICK]: ")
      (grread 5)
      (while (/= 3 (car (setq l (grread 5))))
         (if (= 5 (car l))
            (progn
               (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) i 12.0) p1 p2 nil)))
               (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) i 12.0) p3 p4 nil)))
               (if (< n m)
                  (if (not (equal t1 d1))
                     (progn
                        (grvecs t1)
                        (grvecs d1)
                        (setq t1 d1)
                     )
                  )
                  (if (not (equal t1 d2))
                     (progn
                        (grvecs t1)
                        (grvecs d2)
                        (setq t1 d2)
                     )
                  )
               )
            )
         )
      )
      (grvecs t1)
      (setq d1 (cdr t1))
      (stl_set_lyr "stl-objt")
      (stl_draw_line
         (list (nth 0 d1) (nth 1 d1) (nth 3 d1) (nth 5 d1) (nth 0 d1)) t)
      (stl_draw_line (list (nth 8 d1) (nth 9 d1)) nil)
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (if (= STL_VIEW_MODE "stl_va")
         (princ (strcat "\nDrawing Front Elevation of [" (nth 0 SHP_DATA) "] again"))
         (princ (strcat "\nDrawing Rear Elevation of [" (nth 0 SHP_DATA) "] again"))
      )
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)