;Draw Angle Shape Elevations
(apply '(lambda ( / ang c d e f g h i j k l m n p r ad tgl1 tgl2
                    p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 lp)
   (setq p (getvar "blipmode"))
   (princ (strcat "\nDrawing "
      (cond
         ((= STL_VIEW_MODE "stl_va") "Front Elevation")
         ((= STL_VIEW_MODE "stl_vb") "Rear Elevation")
         ((= STL_VIEW_MODE "stl_vc") "Top View")
         ((= STL_VIEW_MODE "stl_vd") "Bottom View")
      )
      " of [" (nth 0 SHP_DATA) "]")
   )
   (if (not (setq lp (getpoint "\n[PICK] Start point: ")))
      (setq lp (getvar "lastpoint"))
   )
   (while (setq p1 lp p2 (getpoint lp "\n[PICK] End point: "))
      (setq lp p2)
      (setq ang (angle p1 p2))
      (setq a (nth 1 SHP_DATA) b (nth 2 SHP_DATA))
      (setq c (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))
      (cond
         ((= STL_INPUT_MODE "stl_ia")             ;TOS
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq tgl1 t)
            (setq ang (+ ang (* pi 1.5)))
            (setq p3 (polar p1 ang (nth 1 SHP_DATA)))
            (setq p4 (polar p2 ang (nth 1 SHP_DATA)))
            (setq p5 (polar p1 ang c))
            (setq p6 (polar p2 ang c))
            (setq p7 (polar p1 ang (nth 2 SHP_DATA)))
            (setq p8 (polar p2 ang (nth 2 SHP_DATA)))
            (setq p9  (polar p3 (+ ang pi) c))
            (setq p10 (polar p4 (+ ang pi) c))
            (setq p11 (polar p7 (+ ang pi) c))
            (setq p12 (polar p8 (+ ang pi) c))
            (setq ad (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1)
                           (list 256 p1 p2 p2 p8 p8 p7 p7 p1)
                           (list (list 256 p5 p6) (list 256 p9 p10))
                           (list (list 256 p5 p6) (list 256 p11 p12))
                           (list p1 p2 p3 p4)))
         )
         ((= STL_INPUT_MODE "stl_ib")             ;BOS
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq tgl1 t)
            (setq ang (+ ang (* pi 0.5)))
            (setq p3 (polar p1 ang (nth 1 SHP_DATA)))
            (setq p4 (polar p2 ang (nth 1 SHP_DATA)))
            (setq p5 (polar p1 ang c))
            (setq p6 (polar p2 ang c))
            (setq p7 (polar p1 ang (nth 2 SHP_DATA)))
            (setq p8 (polar p2 ang (nth 2 SHP_DATA)))
            (setq p9  (polar p3 (+ ang pi) c))
            (setq p10 (polar p4 (+ ang pi) c))
            (setq p11 (polar p7 (+ ang pi) c))
            (setq p12 (polar p8 (+ ang pi) c))
            (setq ad (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1)
                           (list 256 p1 p2 p2 p8 p8 p7 p7 p1)
                           (list (list 256 p5 p6) (list 256 p9 p10))
                           (list (list 256 p5 p6) (list 256 p11 p12))
                           (list p1 p2 p3 p4)))
         )
         ((= STL_INPUT_MODE "stl_ic")             ;X Axis
            (setq tgl2 t)
            (setq ang (+ ang (* pi 1.5)))
            (setq cp1 p1 cp2 p2)
            (setq p1 (polar cp1 (+ ang pi) (nth 6 SHP_DATA)))
            (setq p2 (polar cp2 (+ ang pi) (nth 6 SHP_DATA)))
            (setq p3 (polar p1 ang (nth 1 SHP_DATA)))
            (setq p4 (polar p2 ang (nth 1 SHP_DATA)))
            (setq p5 (polar p1 ang c))
            (setq p6 (polar p2 ang c))
            (setq ang (+ ang pi))
            (setq p7  (polar cp1 (+ ang pi) (nth 6 SHP_DATA)))
            (setq p8  (polar cp2 (+ ang pi) (nth 6 SHP_DATA)))
            (setq p9  (polar p7 ang (nth 1 SHP_DATA)))
            (setq p10 (polar p8 ang (nth 1 SHP_DATA)))
            (setq p11 (polar p7 ang c))
            (setq p12 (polar p8 ang c))
            (setq ad (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6)
                           (list 256 p7 p8 p8 p10 p10 p9 p9 p7 p11 p12)
                           (list 256 p5 p6)
                           (list 256 p11 p12)
                           (list p1 p2 p7 p8)))
         )
         ((= STL_INPUT_MODE "stl_id")             ;Y Axis
            (setq tgl2 t)
            (setq ang (+ ang (* pi 1.5)))
            (setq cp1 p1 cp2 p2)
            (setq p1 (polar cp1 (+ ang pi) (nth 7 SHP_DATA)))
            (setq p2 (polar cp2 (+ ang pi) (nth 7 SHP_DATA)))
            (setq p3 (polar p1 ang (nth 2 SHP_DATA)))
            (setq p4 (polar p2 ang (nth 2 SHP_DATA)))
            (setq p5 (polar p1 ang c))
            (setq p6 (polar p2 ang c))
            (setq ang (+ ang pi))
            (setq p7  (polar cp1 (+ ang pi) (nth 7 SHP_DATA)))
            (setq p8  (polar cp2 (+ ang pi) (nth 7 SHP_DATA)))
            (setq p9  (polar p7 ang (nth 2 SHP_DATA)))
            (setq p10 (polar p8 ang (nth 2 SHP_DATA)))
            (setq p11 (polar p7 ang c))
            (setq p12 (polar p8 ang c))
            (setq ad (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6)
                           (list 256 p7 p8 p8 p10 p10 p9 p9 p7 p11 p12)
                           (list 256 p5 p6)
                           (list 256 p11 p12)
                           (list p1 p2 p7 p8)))
         )
      )
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (if (and tgl2)
         (progn
            (stl_set_lyr "stl-cntr")
            (stl_draw_line (list
                              (polar cp1 (angle cp2 cp1) 6.0)
                              (polar cp2 (angle cp1 cp2) 6.0)) nil)
            (setq d1 (car ad) d2 (cadr ad) t1 d1)
            (grvecs d1)
            (princ (strcat "\n[DRAG] to toggle about axis and [PICK]"))
            (grread 5)
            (while (/= 3 (car (setq l (grread 5))))
               (if (= 5 (car l))
                  (progn
                     (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p1 p2 nil)))
                     (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p4 p3 nil)))
                     (if (< n m)
                        (if (not (equal t1 d1))
                           (progn
                              (grvecs t1)
                              (grvecs d1)
                              (setq t1 d1 lg 2)
                           )
                        )
                        (if (not (equal t1 d2))
                           (progn
                              (grvecs t1)
                              (grvecs d2)
                              (setq t1 d2 lg 3)
                           )
                        )
                     )
                  )
               )
            )
            (setq t2 t1 t1 (nth lg ad))
         )
      )
      (if (and tgl1)
         (progn
            (setq d1 (car ad) d2 (cadr ad) t1 d1 lg 2)
            (setq p1 (car   (last ad)) p2 (cadr   (last ad)))
            (setq p3 (caddr (last ad)) p4 (cadddr (last ad)))
            (grvecs (car (caddr ad)))
            (grvecs d1)
            (if (/= a b)
               (progn
                  (princ (strcat "\n[DRAG] to change size and [PICK]: Displaying " (rtos a 4) " Leg    "))
                  (grread 5)
                  (while (/= 3 (car (setq l (grread 5))))
                     (if (= 5 (car l))
                        (progn
                           (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p1 p2 nil)))
                           (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p4 p3 nil)))
                           (if (< n m)
                              (if (not (equal t1 d1))
                                 (progn
                                    (princ (strcat "\r[DRAG] to change size or [PICK]: Displaying " (rtos a 4) " Leg    "))
                                    (grvecs t1)
                                    (grvecs d1)
                                    (setq t1 d1 c d1 lg 2)
                                 )
                              )
                              (if (not (equal t1 d2))
                                 (progn
                                    (princ (strcat "\r[DRAG] to change size or [PICK]: Displaying " (rtos b 4) " Leg    "))
                                    (grvecs t1)
                                    (grvecs d2)
                                    (setq t1 d2 c d2 lg 3)
                                 )
                              )
                           )
                        )
                     )
                  )
               )
            )
            (setq t2 t1 d1 (car  (nth lg ad)) t1 d1)
            (setq d2 (cadr (nth lg ad)))
            (princ "\n[DRAG] Outstanding leg and [PICK]: ")
            (grread 5)
            (while (/= 3 (car (setq l (grread 5))))
               (if (= 5 (car l))
                  (progn
                     (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p1 p2 nil)))
                     (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p3 p4 nil)))
                     (if (< n m)
                        (if (not (equal t1 d1))
                           (progn
                              (grvecs t1)
                              (grvecs d1)
                              (setq t1 d1)
                           )
                        )
                        (if (not (equal t1 d2))
                           (progn
                              (grvecs t1)
                              (grvecs d2)
                              (setq t1 d2)
                           )
                        )
                     )
                  )
               )
            )
            (grvecs t1)
         )
      )
      (grvecs t2)
      (stl_set_lyr "stl-objt")
      (setq t2 (list (nth 1 t2) (nth 2 t2) (nth 4 t2) (nth 6 t2)))
      (stl_draw_line t2 t)
      (if (or (= STL_VIEW_MODE "stl_va") (= STL_VIEW_MODE "stl_vc"))
         (stl_set_lyr "stl-hidn")
      )
      (stl_draw_line (cdr t1) nil)
      (setvar "osmode" r)
      (setvar "blipmode" p)
      (command ".undo" "e")
      (princ (strcat "\nDrawing "
         (cond
            ((= STL_VIEW_MODE "stl_va") "Front Elevation")
            ((= STL_VIEW_MODE "stl_vb") "Rear Elevation")
            ((= STL_VIEW_MODE "stl_vc") "Top View")
            ((= STL_VIEW_MODE "stl_vd") "Bottom View")
         )
         " of [" (nth 0 SHP_DATA) "] again")
      )
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" p)
)
'()
)